unit NumbGen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SaveDialog1: TSaveDialog;
    Label7: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  startN, endN, pcs, digits, sheets, cnt1, cnt2, n, tickets : Integer;
  NumberStr : String;  //     

begin

  startN := StrToInt(Edit1.Text);
  endN := StrToInt(Edit2.Text);
  pcs := StrToInt(Edit3.Text);
  digits := StrToInt(Edit4.Text);
  tickets := 0;

  if Frac(((endN-startN)+1)/pcs) > 0 then
    sheets := ((endN-startN)+1) div pcs + 1 else
      sheets := ((endN-startN)+1) div pcs;

  Memo1.Lines.Clear;
  Memo1.Lines.Append('Codes');

  for cnt1 := 0 to sheets-1 do
    begin
      tickets := tickets+1;  // ,   
      n := cnt1+startN;
      NumberStr := IntToStr(n);
      while Length(NumberStr) < digits do NumberStr := '0' + NumberStr;
      if n <= endN then Memo1.Lines.Append(NumberStr)
        else Memo1.Lines.Append('---');

      if pcs > 1 then
        for cnt2 :=1 to pcs-1 do
          begin
            tickets := tickets+1;  //  ,   
            n := n + sheets;
            NumberStr := IntToStr(n);
            while Length(NumberStr) < digits do NumberStr := '0' + NumberStr;
            if n <= endN then Memo1.Lines.Append(NumberStr)
              else Memo1.Lines.Append('---');
          end;
    end;

    Label5.Caption := 'Sheets: ' + IntToStr(sheets);
    Label6.Caption := 'Pieces: ' + IntToStr(pcs);
    Label7.Caption := 'Tickets: ' + IntToStr(tickets);

    SaveDialog1.Execute;
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);

end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  with Edit1 do
    try
      StrToInt(Text);
      Exit;
    except
      on EConvertError do
        begin
          Color := clRed;
          SetFocus;
          ShowMessage('       !');
        end;
    end;
end;

procedure TForm1.Edit3Exit(Sender: TObject);
begin
  with Edit3 do
    try
      StrToInt(Text);
      Exit;
    except
      on EConvertError do
        begin
          Color := clRed;
          SetFocus;
          ShowMessage('       !');
        end;
    end;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
  with Edit2 do
    try
      StrToInt(Text);
      Exit;
    except
      on EConvertError do
        begin
          Color := clRed;
          SetFocus;
          ShowMessage('       !');
        end;
    end;
end;

procedure TForm1.Edit4Exit(Sender: TObject);
begin
  with Edit4 do
    try
      StrToInt(Text);
      Exit;
    except
      on EConvertError do
        begin
          Color := clRed;
          SetFocus;
          ShowMessage('       !');
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnMessage := AppMessage;
  AppendMenu(GetSystemMenu(Form1.Handle, False), MF_SEPARATOR, 149, '');
  AppendMenu(GetSystemMenu(Form1.Handle, False), MF_STRING, 150, '&About');
end;

procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if Msg.message = WM_SYSCOMMAND then
    if Msg.wParam = 150 then
      ShowMessagePos(' 2014 Nikolay Demidov' + chr(10) + '    huck.nd@gmail.com', Form1.Left + 250 , Form1.Top + 160);
end;


end.
